
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  clrBlack
#property indicator_color2  clrWhite
#property indicator_color3  clrBlack
#property indicator_color4  clrWhite
#property indicator_width1  4
#property indicator_width2  4
#property indicator_width3  4
#property indicator_width4  4

//
//
//
//
//

extern ENUM_TIMEFRAMES    TimeFrame          = PERIOD_CURRENT;
extern ENUM_APPLIED_PRICE MA_Price           = 0;
extern int                MA_Length          = 1;
extern ENUM_MA_METHOD     MA_Mode            = 0;
extern int                AtrLength          = 10; 
extern double             Kv                 = 4;  
extern double             MoneyRisk          = 1;
extern bool               alertsOn           = true;
extern bool               alertsOnCurrent    = false;
extern bool               alertsMessage      = true;
extern bool               alertsSound        = false;
extern bool               alertsPushNotif    = false;    // Alerts should send push notification
extern bool               alertsEmail        = false;
extern bool               Interpolate        = true;

extern int                VisualMode         = 0;  

//
//
//
//
//

double UpLine[];
double DnLine[]; 
double UpArrow[];
double DnArrow[]; 
double smax[];
double smin[];
double trend[];
string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
      SetIndexBuffer(0,UpLine);  
      SetIndexBuffer(1,DnLine);  
      SetIndexBuffer(2,UpArrow); 
      SetIndexBuffer(3,DnArrow); 
      SetIndexBuffer(4,smax);
      SetIndexBuffer(5,smin);
      SetIndexBuffer(6,trend);
      
      if(VisualMode==0)
      {
         SetIndexStyle(0,DRAW_LINE);
         SetIndexStyle(1,DRAW_LINE);
      }
      else
      {
         SetIndexStyle(0,DRAW_ARROW);SetIndexArrow(0,159);
         SetIndexStyle(1,DRAW_ARROW);SetIndexArrow(1,159);
      }
      SetIndexStyle(2,DRAW_ARROW);SetIndexArrow(2,108);
      SetIndexStyle(3,DRAW_ARROW);SetIndexArrow(3,108);
      
      //
      //
      // 
      //
      //
      
      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame==-99;
      TimeFrame         = MathMax(TimeFrame,_Period);
      
      
      //
      //
      //
      //
      //
       
      IndicatorShortName(timeFrameToString(TimeFrame)+"  Volty Channel Stop");
return(0);
}
      
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { UpLine[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (TimeFrame==Period())
   {
      for(i=limit; i>=0; i--)
      { 
         if(MA_Price==2 || MA_Price==3)
           {
            double bprice=iMA(NULL,0,MA_Length,0,MA_Mode,2,i);
            double sprice=iMA(NULL,0,MA_Length,0,MA_Mode,3,i);
           }
         else
           {
                  bprice=iMA(NULL,0,MA_Length,0,MA_Mode,MA_Price,i);
                  sprice=iMA(NULL,0,MA_Length,0,MA_Mode,MA_Price,i);
           }
         smin[i]    = sprice - Kv * iATR(NULL,0,AtrLength,i); 
	      smax[i]    = bprice + Kv * iATR(NULL,0,AtrLength,i);
         UpLine[i]  = EMPTY_VALUE;
         DnLine[i]  = EMPTY_VALUE;
         UpArrow[i] = EMPTY_VALUE;
         DnArrow[i] = EMPTY_VALUE;
         trend[i]   = trend[i+1]; 
   
         //
         //
         //
         //
         //

         if (bprice > smax[i+1]) trend[i] =  1;
         if (sprice < smin[i+1]) trend[i] = -1;           
         if (trend[i] == 1)
         {  
     	      if (smin[i] < smin[i+1]) smin[i] = smin[i+1];
               UpLine[i] = smin[i] - (MoneyRisk - 1.0) * iATR(NULL,0,AtrLength,i); if (trend[i+1]!= 1) UpArrow[i] = UpLine[i];
         }
         if (trend[i] ==-1)
         {  
    	      if (smax[i] > smax[i+1]) smax[i] = smax[i+1];
               DnLine[i] = smax[i] + (MoneyRisk - 1.0) * iATR(NULL,0,AtrLength,i); if (trend[i+1]!=-1) DnArrow[i] = DnLine[i];
         }
      }
      manageAlerts();
      return(0);
   }
      
   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   for (i=limit;i>=0; i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         UpLine[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,MA_Price,MA_Length,MA_Mode,AtrLength,Kv,MoneyRisk,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsPushNotif,alertsEmail,0,y);
         DnLine[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,MA_Price,MA_Length,MA_Mode,AtrLength,Kv,MoneyRisk,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsPushNotif,alertsEmail,1,y);
         UpArrow[i] = EMPTY_VALUE;
         DnArrow[i] = EMPTY_VALUE;
            if (UpLine[i]!= EMPTY_VALUE && UpLine[i+1]==EMPTY_VALUE) UpArrow[i]=UpLine[i];
            if (DnLine[i]!= EMPTY_VALUE && DnLine[i+1]==EMPTY_VALUE) DnArrow[i]=DnLine[i];
            
         //
         //
         //
         //
         //
      
         if (!Interpolate || y==iBarShift(NULL,TimeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,TimeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(int k = 1; k < n; k++)
            {
               if (UpLine[i]!=EMPTY_VALUE && UpLine[i+n]!=EMPTY_VALUE) UpLine[i+k] = UpLine[i] + (UpLine[i+n]-UpLine[i])*k/n;
               if (DnLine[i]!=EMPTY_VALUE && DnLine[i+n]!=EMPTY_VALUE) DnLine[i+k] = DnLine[i] + (DnLine[i+n]-DnLine[i])*k/n; 
            }
   }
return(0);         
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; 
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"buy");
         if (trend[whichBar] ==-1) doAlert(whichBar,"sell");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," - ",timeFrameToString(_Period)+" Volty Channel Stop ",doWhat);
          if (alertsMessage)   Alert(message);
          if (alertsEmail)     SendMail(StringConcatenate(Symbol()," Volty Channel Stop "),message);
          if (alertsPushNotif) SendNotification(message);
          if (alertsSound)     PlaySound("alert2.wav");
   }
}